{%- from "shuup/front/macros/general.jinja" import render_field with context -%}
{%- from "canvas/macros/basket.jinja" import render_basket_partial with context -%}
{%- from "canvas/macros/wishlist.jinja" import render_wishlist_content with context -%}

{% macro render_navigation(show_quick_login=True, transparent=False) %}
    <div class="canvas-top-bar canvas-nav__is-animated" id="canvas-top-bar">
        <div class="canvas-top-bar__text" id="canvas-top-bar__text">
            <span>The Canvas: Ethical fashion’s central operating system</span>
            <span>The Slowest fashion in town</span>
            <span>Purpose-Driven</span>
            <span>United brands of ethical fashion</span>
            <span>Unique brands for unique people</span>
        </div>
        <button class="canvas-top-bar__dismiss" id="canvas-top-bar__dismiss" type="button">
            <i class="fa fa-times" aria-hidden="true"></i>
        </button>
    </div>

    <nav class="canvas-nav {% if transparent %}canvas-nav__transparent{% endif %}" role="navigation" aria-label="{% trans %}Main menu{% endtrans %}" id="canvas-nav">
        <div class="container-fluid canvas-nav__container">
            <div class="canvas-nav__logo-wrap canvas-nav__is-animated">
                {{ render_logo() }}
            </div>

            <div class="canvas-nav__links">
                <ul class="canvas-nav__pages">
                    {{ render_cms_nav_list(animated=true) }}
                    {{ render_store_locator_link(animated=true) }}
                    {{ render_brand_links(animated=true) }}
                </ul>
                <ul class="canvas-nav__category-menu-items">
                    {{ render_categories(mobile=False) }}
                </ul>
            </div>
            <div class="canvas-nav__user-actions">
                <div class="hidden-md hidden-lg">
                    {{ render_search_toggle_element() }}
                </div>
                <div class="canvas-nav__user-actions__desktop-only">
                    {{ render_search_toggle_element() }}
                    {{ render_user_nav_element(animated=true) }}
                    {{ render_wishlist_toggle_element(animated=true) }}
                    {{ render_basket_toggle_element(request.basket, btn_id="basket-toggler-desktop", animated=true) }}
                </div>
                <button class="canvas-mobile-nav__toggler canvas-nav__is-animated"
                        id="canvas-mobile-nav__toggler"
                        type="button"
                        aria-haspopup="true"
                        aria-controls="canvas-mobile-nav"
                        aria-expanded="false"
                        aria-label="{% trans %}Toggle mobile menu{% endtrans %}"
                >
                    <svg class="canvas-nav-icon fa fa-bars" aria-hidden="true" viewBox="0 0 24 24" xmlns="http://www.w3.org/2000/svg">
                    <rect x="1" y="4.3" width="22" height="3" fill="currentColor"/>
                    <rect x="1" y="10.7" width="22" height="3" fill="currentColor"/>
                    <rect x="1" y="17.2" width="22" height="3" fill="currentColor"/>
                    </svg>
                </button>
            </div>
            {{ render_search_dialog() }}
            <div id="canvas-megamenu__bg" class="canvas-megamenu__bg"></div>
        </div>
    </nav>
    {{ render_wishlist_dialog() }}
    {{ render_basket_dialog() }}
    {{ render_mobile_nav() }}
{% endmacro %}

{% macro render_wishlist_toggle_element(animated=false) %}
    <button class="canvas-wishlist-dialog__toggler{% if animated %} canvas-nav__is-animated{% endif %}"
            type="button"
            aria-haspopup="true"
            aria-controls="canvas-wishlist-dialog"
            aria-expanded="false"
            aria-label="{% trans %}Toggle wishlist{% endtrans %}"
    >
        <svg class="canvas-nav-icon" aria-hidden="true" viewBox="0 0 24 24" xmlns="http://www.w3.org/2000/svg">
        <path d="M12.0042 22.1697L11.2824 21.6284C10.9162 21.3524 2.27125 14.7877 1.14618 9.06685C0.907371 7.83564 0.960439 6.64158 1.3107 5.51651C1.68749 4.32245 2.36147 3.29821 3.32733 2.48625C4.17113 1.7592 5.14761 1.29219 6.23023 1.10114C7.29692 0.910094 8.3583 0.989699 9.38785 1.33996C10.3696 1.66899 11.2453 2.22091 11.9989 2.9798C12.7365 2.23152 13.6228 1.67429 14.6099 1.33996C15.6394 0.995006 16.7008 0.915401 17.7675 1.10114C18.8448 1.29219 19.8266 1.76451 20.6757 2.49687C21.6309 3.30883 22.3102 4.32776 22.687 5.52182C23.0373 6.64689 23.0957 7.84095 22.8515 9.07216C21.7265 14.793 13.0815 21.3577 12.7153 21.6337L12.0042 22.1697ZM7.3606 3.38312C7.1271 3.38312 6.89359 3.40435 6.65478 3.44681C5.99141 3.56356 5.41295 3.84483 4.88757 4.30122C4.25604 4.83192 3.8421 5.46344 3.59798 6.23295C3.36448 6.98653 3.32733 7.76134 3.49715 8.61045C4.21359 12.251 9.3507 17.0219 12.0095 19.1659C14.6682 17.0219 19.8054 12.251 20.5218 8.61045C20.6863 7.76134 20.6545 6.98653 20.421 6.23295C20.1822 5.46344 19.7629 4.83722 19.142 4.31184C18.606 3.85013 18.0275 3.56887 17.3642 3.45211C16.6902 3.33006 16.0427 3.38312 15.3847 3.60071C14.7213 3.8236 14.1535 4.18978 13.644 4.72578L12.0148 6.37093L10.4015 4.7417C9.87608 4.18978 9.30824 3.8236 8.64488 3.60071C8.2044 3.45742 7.78516 3.38312 7.3606 3.38312Z" fill="currentColor"/>
        </svg>
        {# TODO: wishlist counter
        <span class="canvas-nav__counter-badge"></span>
        #}
    </button>
{% endmacro %}

{% macro render_wishlist_dialog() %}
    <div class="canvas-dialog canvas-dialog__right canvas-wishlist-dialog" id="canvas-wishlist-dialog" tabindex="-1">
        <button type="button"
                class="canvas-dialog__close-btn"
                id="canvas-wishlist-dialog__close-btn"
                aria-label="{% trans %}Close wishlist{% endtrans %}"
        >
            <svg class="canvas-nav-icon" aria-hidden="true" viewBox="0 0 24 24" xmlns="http://www.w3.org/2000/svg"><path d
            ="M20.3927 23L12.0165 14.6329L3.53465 23L1 20.4001L9.38284 12.0198L1.0066 3.5207L3.52145 1.0066L12.0165 9.38032L20.4059 1L23 3.52729L14.5049 12.0132L23 20.3869L20.3927 23Z" fill="currentColor"/>
            </svg>
        </button>
        {{ render_wishlist_content() }}
    </div>
{% endmacro %}

{% macro render_basket_toggle_element(basket=None, btn_id="", animated=false) %}
    {% if not xtheme.get("catalog_mode") %}
        <button class="canvas-basket-dialog__toggler{% if animated %} canvas-nav__is-animated{% endif %}"
                id="{{ btn_id }}"
                type="button"
                aria-haspopup="true"
                aria-controls="canvas-basket-dialog"
                aria-expanded="false"
                aria-label="{% trans %}Toggle basket{% endtrans %}"
        >
            <svg class="canvas-nav-icon" aria-hidden="true" viewBox="0 0 24 24" xmlns="http://www.w3.org/2000/svg">
            <path d="M16.9717 6.24596C16.8532 5.47083 16.5175 4.30566 15.5943 3.36759C14.7006 2.45916 13.4861 2 11.9901 2C10.4942 2 9.27962 2.45916 8.38599 3.36759C7.45781 4.30566 7.12703 5.4807 7.00853 6.24596H1L1.16786 7.5C1.2123 7.83573 2.26392 15.7648 3.11805 18.4358C3.92281 20.9686 6.12971 21.6055 7.44793 21.6055C7.55161 21.6055 7.6553 21.6005 7.74911 21.5956H16.2509C17.5148 21.6993 20.0081 21.171 20.882 18.4358C21.7361 15.7648 22.7877 7.83573 22.8321 7.5L23 6.24596H16.9717ZM9.54623 5.51526C10.0004 4.64138 10.8003 4.22172 11.9901 4.22172C12.8739 4.22172 13.5355 4.44883 14.0045 4.91786C14.3995 5.31284 14.6019 5.8263 14.7056 6.2509H9.27469C9.329 6.01885 9.41293 5.76706 9.54623 5.51526ZM18.754 17.7644C18.206 19.4776 16.5768 19.3986 16.404 19.3838L7.68987 19.3788L7.57631 19.3838C7.50225 19.3887 5.79398 19.5417 5.22621 17.7644C4.62388 15.8784 3.87344 10.8326 3.53771 8.46768H6.93941V10.329C6.93941 10.9412 7.43806 11.4399 8.05027 11.4399C8.66248 11.4399 9.16113 10.9412 9.16113 10.329V8.46768H14.8191V10.329C14.8191 10.9412 15.3178 11.4399 15.93 11.4399C16.5422 11.4399 17.0409 10.9412 17.0409 10.329V8.46768H20.4426C20.1068 10.8326 19.3514 15.8784 18.754 17.7644Z" fill="currentColor"/>
            </svg>
            <span class="canvas-nav__counter-badge basket-counter-badge">{% if basket.product_count > 0 %}{{ basket.product_count }}{% endif %}</span>
        </button>
    {% endif %}
{% endmacro %}

{% macro render_basket_dialog() %}
    {% if not xtheme.get("catalog_mode") %}
        <div class="canvas-dialog canvas-dialog__right canvas-basket-dialog" id="canvas-basket-dialog" tabindex="-1">
            <button type="button"
                    class="canvas-dialog__close-btn"
                    id="canvas-basket-dialog__close-btn"
                    aria-label="{% trans %}Close cart{% endtrans %}"
            >
                <svg class="canvas-nav-icon" aria-hidden="true" viewBox="0 0 24 24" xmlns="http://www.w3.org/2000/svg"><path d
                ="M20.3927 23L12.0165 14.6329L3.53465 23L1 20.4001L9.38284 12.0198L1.0066 3.5207L3.52145 1.0066L12.0165 9.38032L20.4059 1L23 3.52729L14.5049 12.0132L23 20.3869L20.3927 23Z" fill="currentColor"/>
                </svg>
            </button>

            <div class="nav-basket-element" id="navigation-basket-partial" aria-label="{% trans %}Shopping cart{% endtrans %}">
                {{ render_basket_partial(request.basket) }}
            </div>
        </div>
    {% endif %}
{% endmacro %}

{% macro render_search_toggle_element() %}
    <button class="canvas-search-dialog__toggler canvas-nav__is-animated"
            type="button"
            aria-haspopup="true"
            aria-controls="canvas-search-dialog"
            aria-expanded="false"
            aria-label="{% trans %}Toggle search{% endtrans %}"
    >
        <svg class="canvas-nav-icon" aria-hidden="true" viewBox="0 0 24 24" xmlns="http://www.w3.org/2000/svg">
        <path d="M15.2072 15.8964V17.1157C15.2072 17.3277 15.2602 17.4867 15.4193 17.6458L20.7735 23L23 20.7735L17.6458 15.4193C17.4867 15.2602 17.3277 15.2072 17.1157 15.2072H15.8964L16.2675 14.7831C17.4867 13.2458 18.0699 11.4964 18.0699 9.53494C18.0699 7.99759 17.6988 6.56627 16.9036 5.24096C16.1614 3.96867 15.1012 2.90843 13.8289 2.16627C12.5566 1.4241 11.0723 1 9.53494 1C7.99759 1 6.56627 1.37108 5.24096 2.16627C3.96867 2.90843 2.90843 3.96867 2.16627 5.24096C1.4241 6.51325 1 7.99759 1 9.53494C1 11.0723 1.37108 12.5036 2.16627 13.8289C2.90843 15.1012 3.96867 16.1614 5.24096 16.9036C6.51325 17.6458 7.99759 18.0699 9.53494 18.0699C11.4964 18.0699 13.2458 17.4867 14.7831 16.2675L15.2072 15.8964ZM9.53494 15.5783C8.42169 15.5783 7.41446 15.3133 6.51325 14.7831C5.61205 14.253 4.86988 13.5108 4.33976 12.6096C3.80964 11.7084 3.54458 10.7012 3.54458 9.58795C3.54458 8.4747 3.80964 7.46747 4.33976 6.56627C4.86988 5.66506 5.61205 4.92289 6.51325 4.39277C7.41446 3.86265 8.42169 3.59759 9.53494 3.59759C10.6482 3.59759 11.6554 3.86265 12.5566 4.39277C13.4578 4.92289 14.2 5.66506 14.7301 6.56627C15.2602 7.46747 15.5253 8.4747 15.5253 9.58795C15.5253 10.7012 15.2602 11.7084 14.7301 12.6096C14.2 13.5108 13.4578 14.253 12.5566 14.7831C11.6024 15.3133 10.5952 15.5783 9.53494 15.5783Z" fill="currentColor"/>
        </svg>
    </button>
{% endmacro %}

{% macro render_search_dialog() %}
    <div class="canvas-search-dialog" id="canvas-search-dialog">
        <div id="canvas-search-page-toggler" class="canvas-dialog__page-fade hidden-md hidden-lg" style="opacity: 1; visibility: visible;"></div>
        <div class="container">
            <form method="get" action="{{ url('shuup:product_search') }}" class="canvas-search-dialog__form" role="search">
                <input type="search" id="canvas-search-dialog__form-input" name="q" class="canvas-search-dialog__form-input" placeholder="{% trans %}Search{% endtrans %}" autocomplete="off" required>
                <button type="submit" class="btn canvas-search-dialog__form-submit-btn">
                    <svg class="canvas-search-dialog__form-input-icon" aria-hidden="true" viewBox="0 0 24 24" xmlns="http://www.w3.org/2000/svg">
                        <path d="M15.2072 15.8964V17.1157C15.2072 17.3277 15.2602 17.4867 15.4193 17.6458L20.7735 23L23 20.7735L17.6458 15.4193C17.4867 15.2602 17.3277 15.2072 17.1157 15.2072H15.8964L16.2675 14.7831C17.4867 13.2458 18.0699 11.4964 18.0699 9.53494C18.0699 7.99759 17.6988 6.56627 16.9036 5.24096C16.1614 3.96867 15.1012 2.90843 13.8289 2.16627C12.5566 1.4241 11.0723 1 9.53494 1C7.99759 1 6.56627 1.37108 5.24096 2.16627C3.96867 2.90843 2.90843 3.96867 2.16627 5.24096C1.4241 6.51325 1 7.99759 1 9.53494C1 11.0723 1.37108 12.5036 2.16627 13.8289C2.90843 15.1012 3.96867 16.1614 5.24096 16.9036C6.51325 17.6458 7.99759 18.0699 9.53494 18.0699C11.4964 18.0699 13.2458 17.4867 14.7831 16.2675L15.2072 15.8964ZM9.53494 15.5783C8.42169 15.5783 7.41446 15.3133 6.51325 14.7831C5.61205 14.253 4.86988 13.5108 4.33976 12.6096C3.80964 11.7084 3.54458 10.7012 3.54458 9.58795C3.54458 8.4747 3.80964 7.46747 4.33976 6.56627C4.86988 5.66506 5.61205 4.92289 6.51325 4.39277C7.41446 3.86265 8.42169 3.59759 9.53494 3.59759C10.6482 3.59759 11.6554 3.86265 12.5566 4.39277C13.4578 4.92289 14.2 5.66506 14.7301 6.56627C15.2602 7.46747 15.5253 8.4747 15.5253 9.58795C15.5253 10.7012 15.2602 11.7084 14.7301 12.6096C14.2 13.5108 13.4578 14.253 12.5566 14.7831C11.6024 15.3133 10.5952 15.5783 9.53494 15.5783Z" fill="#fff"/>
                    </svg>
                </button>
            </form>

            {# TODO: popular search terms/suggestions
            <div class="canvas-search-dialog__popular-terms">
                <h3>{% trans %}Popular terms{% endtrans %}:</h3>
                <div class="canvas-search-dialog__popular-terms__list">
                    <span>
                        <button type="button" value="lorem ipsum">lorem ipsum</button>
                    </span>
                    <span>
                        <button type="button" value="dolor sit amet">dolor sit amet</button>
                    </span>
                    <span>
                        <button type="button" value="consectetur">consectetur</button>
                    </span>
                    <span>
                        <button type="button" value="lorem ipsum">lorem ipsum</button>
                    </span>
                    <span>
                        <button type="button" value="dolor sit amet">dolor sit amet</button>
                    </span>
                </div>
            </div>
            #}
        </div>
        <button type="button"
                class="canvas-search-dialog__close-btn"
                id="canvas-search-dialog__close-btn"
                aria-label="{% trans %}Close search{% endtrans %}"
        >
            <svg class="canvas-nav-icon" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 53.46 53.36"><g fill="currentColor" id="Layer_2" data-name="Layer 2"><g id="Layer_1-2" data-name="Layer 1"><polygon points="53.46 4.38 49.08 0 26.78 22.3 4.48 0 0 4.38 22.3 26.68 0 48.98 4.48 53.36 26.78 31.06 49.08 53.36 53.46 48.98 31.16 26.68 53.46 4.38"/></g></g></svg>
        </button>
    </div>
{% endmacro %}

{% macro render_user_nav_element(animated=false) %}
    <div class="canvas-nav__user-element dropdown">
        {% if user.is_authenticated %}
            <button type="button" class="dropdown-toggle{% if animated %} canvas-nav__is-animated{% endif %}" data-toggle="dropdown" aria-label="{% trans %}Open user menu{% endtrans %}">
                <svg class="canvas-nav-icon" aria-hidden="true"  viewBox="0 0 24 24" xmlns="http://www.w3.org/2000/svg">
                <path d="M21.2642 14.6892C20.3393 13.503 19.0373 12.8371 17.8437 12.4573C17.8695 12.4157 17.8954 12.3792 17.9212 12.3376C18.5309 11.2763 18.8409 10.1213 18.8409 8.88828C18.8409 7.65526 18.5309 6.50028 17.9212 5.43894C17.3115 4.3828 16.4693 3.53478 15.4256 2.92607C14.3768 2.31216 13.2245 2 12 2C10.7755 2 9.62842 2.31216 8.57438 2.92607C7.52551 3.53998 6.68331 4.38801 6.07879 5.43894C5.4691 6.49507 5.15909 7.65526 5.15909 8.88828C5.15909 10.1213 5.4691 11.2763 6.07879 12.3376C6.10462 12.3792 6.13045 12.4209 6.15629 12.4573C4.96791 12.8371 3.6607 13.503 2.73583 14.6892C0.700091 17.3009 1.0101 21.2445 1.0256 21.411L1.11861 22.4828H22.8814L22.9744 21.411C22.9899 21.2445 23.2999 17.3009 21.2642 14.6892ZM8.08869 6.61473C8.49687 5.90718 9.03939 5.3609 9.74208 4.94989C10.4448 4.53888 11.1836 4.34118 12 4.34118C12.8164 4.34118 13.5552 4.53888 14.2579 4.94989C14.9606 5.3609 15.5031 5.90718 15.9113 6.61473C16.3195 7.32229 16.5158 8.06627 16.5158 8.88828C16.5158 9.7103 16.3195 10.4543 15.9113 11.1618C15.6633 11.5937 15.3533 11.9682 14.9554 12.3116C14.7023 12.5353 14.4801 12.6966 14.2528 12.8267C13.5501 13.2377 12.8112 13.4354 11.9948 13.4354C11.1785 13.4354 10.4396 13.2377 9.73692 12.8267C9.50958 12.6966 9.2874 12.5301 9.03423 12.3064C8.64155 11.963 8.32637 11.5832 8.07836 11.1566C7.67018 10.4491 7.47384 9.7051 7.47384 8.88308C7.47384 8.06107 7.68051 7.32229 8.08869 6.61473ZM3.34035 20.1416C3.39202 19.0438 3.63486 17.327 4.5649 16.1355C5.41226 15.0482 6.89515 14.606 7.94402 14.4239C8.15586 14.5852 8.3677 14.7256 8.57954 14.8505C9.62841 15.4644 10.7806 15.7766 12.0052 15.7766C13.2297 15.7766 14.3768 15.4644 15.4308 14.8505C15.6426 14.7256 15.8493 14.5852 16.0663 14.4239C17.11 14.6008 18.5929 15.043 19.4454 16.1355C20.3755 17.327 20.6183 19.0438 20.67 20.1416H3.34035Z" fill="currentColor" />
                </svg>
            </button>
            <ul class="dropdown-menu" role="menu">
                {% set person_name = (request.person.firstname or request.user.username) %}

                <li class="dropdown-header">{{ person_name|capitalize }}</li>

                {% if shuup.general.is_shop_admin() %}
                    <li>
                        <a href="{{ url('shuup_admin:dashboard') }}">
                            {% trans %}Admin Panel{% endtrans %}
                        </a>
                    </li>
                {% endif %}
                {% if request.person and shuup.urls.has_url("shuup:dashboard") %}
                    <li>
                        <a href="{{ url('shuup:dashboard') }}">
                            {% trans %}My Account{% endtrans %}
                        </a>
                    </li>
                {% endif %}
                <li>
                    <a href="{{ url('shuup:logout') }}">
                        {% trans %}Logout{% endtrans %}
                    </a>
                </li>
            </ul>
        {% else %}
            <a href="{{ url('shuup:login') }}" class="nav-button{% if animated %} canvas-nav__is-animated{% endif %}" aria-label="{% trans %}User login{% endtrans %}">
                <svg class="canvas-nav-icon" aria-hidden="true"  viewBox="0 0 24 24" xmlns="http://www.w3.org/2000/svg">
                <path d="M21.2642 14.6892C20.3393 13.503 19.0373 12.8371 17.8437 12.4573C17.8695 12.4157 17.8954 12.3792 17.9212 12.3376C18.5309 11.2763 18.8409 10.1213 18.8409 8.88828C18.8409 7.65526 18.5309 6.50028 17.9212 5.43894C17.3115 4.3828 16.4693 3.53478 15.4256 2.92607C14.3768 2.31216 13.2245 2 12 2C10.7755 2 9.62842 2.31216 8.57438 2.92607C7.52551 3.53998 6.68331 4.38801 6.07879 5.43894C5.4691 6.49507 5.15909 7.65526 5.15909 8.88828C5.15909 10.1213 5.4691 11.2763 6.07879 12.3376C6.10462 12.3792 6.13045 12.4209 6.15629 12.4573C4.96791 12.8371 3.6607 13.503 2.73583 14.6892C0.700091 17.3009 1.0101 21.2445 1.0256 21.411L1.11861 22.4828H22.8814L22.9744 21.411C22.9899 21.2445 23.2999 17.3009 21.2642 14.6892ZM8.08869 6.61473C8.49687 5.90718 9.03939 5.3609 9.74208 4.94989C10.4448 4.53888 11.1836 4.34118 12 4.34118C12.8164 4.34118 13.5552 4.53888 14.2579 4.94989C14.9606 5.3609 15.5031 5.90718 15.9113 6.61473C16.3195 7.32229 16.5158 8.06627 16.5158 8.88828C16.5158 9.7103 16.3195 10.4543 15.9113 11.1618C15.6633 11.5937 15.3533 11.9682 14.9554 12.3116C14.7023 12.5353 14.4801 12.6966 14.2528 12.8267C13.5501 13.2377 12.8112 13.4354 11.9948 13.4354C11.1785 13.4354 10.4396 13.2377 9.73692 12.8267C9.50958 12.6966 9.2874 12.5301 9.03423 12.3064C8.64155 11.963 8.32637 11.5832 8.07836 11.1566C7.67018 10.4491 7.47384 9.7051 7.47384 8.88308C7.47384 8.06107 7.68051 7.32229 8.08869 6.61473ZM3.34035 20.1416C3.39202 19.0438 3.63486 17.327 4.5649 16.1355C5.41226 15.0482 6.89515 14.606 7.94402 14.4239C8.15586 14.5852 8.3677 14.7256 8.57954 14.8505C9.62841 15.4644 10.7806 15.7766 12.0052 15.7766C13.2297 15.7766 14.3768 15.4644 15.4308 14.8505C15.6426 14.7256 15.8493 14.5852 16.0663 14.4239C17.11 14.6008 18.5929 15.043 19.4454 16.1355C20.3755 17.327 20.6183 19.0438 20.67 20.1416H3.34035Z" fill="currentColor" />
                </svg>
            </a>
        {% endif %}
    </div>
{% endmacro %}

{% macro render_logo() %}
    <a href="/" title="{% trans %}Homepage{% endtrans %}">
        <img class="logo-black" src="{{ shuup_static('canvas/img/canvas-logo-black.svg') }}" alt="{{ request.shop.public_name }} {% trans %}logo{% endtrans %}">
        <img class="logo-white" src="{{ shuup_static('canvas/img/canvas-logo-white.svg') }}" alt="{{ request.shop.public_name }} {% trans %}logo{% endtrans %}">
    </a>
{% endmacro %}

{% macro render_mobile_nav() %}
    <nav class="canvas-mobile-nav" id="canvas-mobile-nav" tabindex="-1">
        <button type="button"
                class="canvas-dialog__close-btn"
                id="canvas-mobile-nav__close-btn"
                aria-label="{% trans %}Close navigation{% endtrans %}"
        >
            <svg class="canvas-nav-icon" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 53.46 53.36"><g fill="currentColor" id="Layer_2" data-name="Layer 2"><g id="Layer_1-2" data-name="Layer 1"><polygon points="53.46 4.38 49.08 0 26.78 22.3 4.48 0 0 4.38 22.3 26.68 0 48.98 4.48 53.36 26.78 31.06 49.08 53.36 53.46 48.98 31.16 26.68 53.46 4.38"/></g></g></svg>
        </button>

        <div class="canvas-mobile-nav__top">
            <div class="canvas-mobile-nav__actions">
                {{ render_user_nav_element() }}
                {{ render_wishlist_toggle_element() }}
                {{ render_basket_toggle_element(request.basket, btn_id="basket-toggle-mobile") }}
            </div>
        </div>

        <div class="canvas-mobile-nav__bottom">
            <ul class="canvas-mobile-nav__categories">
                {{ render_categories(mobile=True) }}
            </ul>

            <ul class="canvas-mobile-nav__pages">
                {{ render_cms_nav_list() }}
                {{ render_store_locator_link() }}
                {{ render_brand_links() }}
            </ul>
        </div>
    </nav>
{% endmacro %}

{% macro render_categories(mobile=False) %}
    {%- cache 86400 'categories-nav' -%}
    {%- set root_categories = shuup.general.get_root_categories() -%}
    {% if mobile %}
        {% for c in root_categories if c.visible_in_menu recursive %}
            {% set children = c.get_children() %}
            <li class="level-{{ c.level }} category-link{% if children %} is-parent{% endif %}{% if category and c == category %} current is-open{% endif %}{% if category and c in category.get_ancestors(include_self=False) %} is-open{% endif %}">
                <a href="{{ url('shuup:category', pk=c.pk, slug=c.slug) }}">
                    {{ c.name }}
                </a>
                {% if children %}
                    <button class="toggle-icon" type="button" aria-expanded="{% if (category and c == category) or (category and c in category.get_ancestors(include_self=False)) %}true{% else %}false{% endif %}" aria-controls="child-of-{{ c.pk }}">
                        <svg class="icon-plus" viewBox="0 0 24 24" xmlns="http://www.w3.org/2000/svg">
                            <path d="M14 23H10L10 1L14 1L14 23Z" fill="currentColor"/>
                            <path d="M1 14L1 10L23 10V14L1 14Z" fill="currentColor"/>
                        </svg>
                        <svg class="icon-minus" viewBox="0 0 24 24" xmlns="http://www.w3.org/2000/svg">
                            <path d="M1 14L1 10L23 10V14L1 14Z" fill="currentColor"/>
                        </svg>
                        <span class="sr-only">
                            {%- trans category_name = c.name -%}
                                Toggle children for {{ category_name }}
                            {%- endtrans -%}
                        </span>
                    </button>
                    <ul id="child-of-{{ c.pk }}">
                        {{ loop(children) }}
                    </ul>
                {% endif %}
            </li>
        {% endfor %}
        {{ render_giftcard_list_item(megamenu=false, animated=false) }}
    {% else %}
        {% for c in root_categories if c.visible_in_menu %}
            {% set children = c.get_children() %}

            <li class="level-{{ c.level }} category-link{% if children %} is-parent{% endif %}{% if category and c == category %} current{% endif %} canvas-nav__is-animated">
                <a href="{{ url('shuup:category', pk=c.pk, slug=c.slug) }}" data-text="{{ c.name }}">
                    {{ c.name }}
                </a>

                {% if children and c.level == 0 %}
                    <div class="canvas-megamenu__container">
                        <div class="canvas-megamenu__content">
                            <ul style="width: 100%!important;">
                                {% for child in children recursive %}
                                    {% set child_children = child.get_children() %}
                                    <li class="level-{{ child.level }} category-link{% if child_children %} is-parent{% endif %}{% if category and c == category %} current{% endif %}">
                                        <a href="{{ url('shuup:category', pk=child.pk, slug=child.slug) }}">
                                            {{ child.name }}
                                        </a>
                                        {% if child_children %}
                                            <ul>
                                                {{ loop(child_children) }}
                                            </ul>
                                        {% endif %}
                                    </li>
                                {% endfor %}
                            </ul>
                            {% set category_image = c.image|thumbnail(size=(800,600), crop="smart", upscale=True) %}
                            {% if category_image %}
                                <div class="canvas-megamenu__category-image">
                                    <img src="{{ category_image }}" alt="">
                                </div>
                            {% endif %}
                        </div>
                    </div>
                {% endif %}
            </li>
        {% endfor %}
        {{ render_giftcard_list_item(megamenu=true, animated=true) }}
    {% endif %}
    {%- endcache -%}
{% endmacro %}

{% macro render_giftcard_list_item(megamenu=false, animated=false) %}
    {# TODO
    <li class="level-0 giftcard-link is-parent{% if request.path == '/gift-cards/' %} current{% endif %}{% if animated %} canvas-nav__is-animated{% endif %}">
        <a href="#" data-text="{% trans %}Gift Cards{% endtrans %}">{% trans %}Gift Cards{% endtrans %}</a>
        {% if megamenu %}
            <div class="canvas-megamenu__container">
                <div class="canvas-megamenu__content">
                    Giftcards
                </div>
            </div>
        {% endif %}
    </li>
    #}
{% endmacro %}

{% macro render_brand_links(animated=false) %}
    <li class="level-0 vendors-link is-parent{% if request.path == '/v/' %} current{% endif %}{% if animated %} canvas-nav__is-animated{% endif %}">
        <a href="/v/">
            {% trans %}Brands{% endtrans %}
        </a>
        <ul>
            <li class="{% if request.path == url('shuup:vendor_register_info') %} current{% endif %}">
                <a href="{{ url('shuup:vendor_register_info') }}">
                    {% trans %}Join The Canvas as a Brand{% endtrans %}
                </a>
            </li>
            <li>
                <a href="{{ url('shuup_admin:dashboard') }}">
                    {% trans %}Brand Login{% endtrans %}
                </a>
            </li>
        </ul>
    </li>
{% endmacro %}

{% macro render_cms_nav_list(animated=false) %}
    {%- if shuup.simple_cms -%}
        {%- for page in xtheme.get_cms_navigation_links(request) -%}
            {% set children = page.children %}
            <li class="level-{{ loop.depth0 }} cms-link{% if request.path == '%s/' % page.url %} current{% endif %}{% if children %} is-parent{% endif %}{% if animated %} canvas-nav__is-animated{% endif %}">
                <a href="{{ page.url }}">
                    {{ page.text }}
                </a>
                {% if children %}
                    <ul>
                        {% for child in children %}
                            <li class="level-{{ loop.depth }} cms-link{% if request.path == '/%s/' % child.url %} current{% endif %}">
                                <a href="{{ url('shuup:cms_page', url=child.url) }}">
                                    {{ child }}
                                </a>
                            </li>
                        {% endfor %}
                    </ul>
                {% endif %}
            </li>
        {%- endfor -%}
    {%- endif -%}
{% endmacro %}

{% macro render_store_locator_link(animated=false) %}
    <li class="level-0 stores-link{% if request.path == url('shuup:discover-our-stores') %} current{% endif %}{% if animated %} canvas-nav__is-animated{% endif %}">
        <a href="{{ url('shuup:discover-our-stores') }}">
            {% trans %}Store locator{% endtrans %}
        </a>
    </li>
{% endmacro %}
